<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.6.0
 * @lastmodified    June 17, 2024
 *
 *
 */

function _404_build_pagelist($parent, $this_page, $usebakery = 0 , $useofa = 0) {
      global $database, $links_404;
      $iterated_parents = array(); // keep count of already iterated parents to prevent duplicates
 
      $table_pages = TABLE_PREFIX."pages";
      if ( $query = $database->query("SELECT link, menu_title, page_title, page_id, level 
            FROM ".$table_pages." 
            WHERE parent = ".$parent." 
            ORDER BY level, position ASC")) {
            while($res = $query->fetchRow()) {
                  if ($res['page_id'] != $this_page) {
						$extra = SEP4;
						if($items = _404_get_one_pages ($res['page_id'], $res['link'],$res['level'],$usebakery,$useofa)) {
							$extra .= implode(SEP2,$items);
						}
                        $links_404[$res['page_id']] = $res['page_id'].SEP4.str_repeat("  -  ",$res['level']).$res['menu_title'].' ('.$res['page_title'].')'.$extra;
                  } 
                  if (!in_array($res['page_id'], $iterated_parents)) {
                        _404_build_pagelist($res['page_id'], $this_page,$usebakery,$useofa);
                        $iterated_parents[] = $res['page_id'];
                  }
            }
      }
}
 
 
function msg($msg_id = NULL) {
	global $MOD_404;
	if (isset($MOD_404[$msg_id])) 
		echo $MOD_404[$msg_id];
	else
		echo '<span style="color:red;">'.$msg_id.'</span>';
}
function retmsg($msg_id = NULL) {
	global $MOD_404;
	if (isset($MOD_404[$msg_id])) 
		return $MOD_404[$msg_id];
	else
		return '<span style="color:red;">'.$msg_id.'</span>';
}

function _404_referer() {
	$ref = "";
	if (defined( 'ORG_REFERER' )) {
		$ref = ORG_REFERER;
	} elseif (isset($referer)) {
		$ref = $referer;
	} elseif (isset($_SERVER['HTTP_REFERER'])) {
		$ref = $_SERVER['HTTP_REFERER'];
	} 	
	if(!$ref) $ref = "-";
	return $ref;
}

function _404_mail ($toaddress = NULL, $fromaddress = NULL, $subject = NULL, $html_message = NULL, $plain_message = NULL) {
	if (!$toaddress || !$fromaddress || !$subject || !$html_message) {
		return false;
	}	
	if (!$plain_message) {
		$plain_message = str_ireplace("<br/>","\n",$html_message);
		$plain_message = str_ireplace("<br />","\n",$plain_message);
		$plain_message = str_ireplace("<br>","\n",$plain_message);
		$plain_message = strip_tags($plain_message);
	}
	
	if (!class_exists('wbmailer')){
		require_once(WB_PATH."/framework/class.wbmailer.php");
	}
	$toArray = explode(',',$toaddress);
	
	$myMail = new wbmailer();
	$myMail->From = $fromaddress;                     	// FROM:		
	foreach ($toArray as $toAddr) {							// TO:
		$myMail->AddAddress($toAddr);
	}
	$myMail->Subject = $subject;                          	// SUBJECT
	$myMail->Body = $html_message; 		                     	// CONTENT (HTML)
	$myMail->AltBody = $plain_message;			              	// CONTENT (TEXT)
	$myMail->SMTPOptions = array( // allow self_signed ssl.
		'ssl' => array(
			'verify_peer' => false,
			'verify_peer_name' => false,
			'allow_self_signed' => true
		)
	); 
	if (!$myMail->Send()) {
		return false;
	} else {
		return true;
	}
}

function _404_history ($limit = 100) {
	global $database, $MOD_404;
	
	$rval = '<table class="mod_404_table" style="width: 100%;white-space:nowrap;table-layout:fixed;" cellpadding="2" cellspacing="2" border="0">';
	$rval .= '<tr>
		<th style="width:90px;">'.$MOD_404['TXT_HIST_DATE'].'</th>
		<th style="width:90px;">'.$MOD_404['TXT_HIST_TIME'].'</th>
		<th style="width:40px;"> </th>
		<th >'.$MOD_404['TXT_HIST_URL'].'</th>
		</tr>';
	if ( $query = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404_errors ORDER BY `id` DESC LIMIT $limit")) {
		while($res = $query->fetchRow()) {
			$first = $res['timestamp']; $last = $first - 3600;
			$count_errors = intval($database->get_one("SELECT count(`iphash`) FROM ".TABLE_PREFIX."mod_404_errors WHERE `iphash` = '{$res['iphash']}' AND `timestamp` BETWEEN '$last' AND '$first'"));

			$url = $res['redirect'] ? '<span style="color:#700;">'.$res['url'].'</span> -> <span style="color:#070;">'.$res['redirect']. '</span>' : $res['url'];
			$title_url = $res['redirect'] ? $res['url']."\n->\n".$res['redirect'] : $res['url'];
			$rval .= '<tr>';
			$rval .= '<td style="text-align:center;background:#fff;">'.date(DATE_FORMAT,$res['timestamp']+TIMEZONE).'</td>';
			$rval .= '<td style="text-align:center;background:#fff;">'.date(TIME_FORMAT,$res['timestamp']+TIMEZONE).'</td>';
			$rval .= '<td style="text-align:center;background:#fff;">
			<label class="btn-404" for="modal-'.$res['id'].'">&hellip;</label>
<input class="modal-state" id="modal-'.$res['id'].'" type="checkbox" />
<div class="modal_404"><label class="modal__bg_404" for="modal-'.$res['id'].'"></label>
<div class="modal__box_404"><table cellpadding="2" cellspacing="2" border="0">
<tr><td><b>'.$MOD_404['TXT_TIMESTAMP'].'</b>:</td><td> '.date(DATE_FORMAT.' '.TIME_FORMAT,$res['timestamp']+TIMEZONE).'<br>
<tr><td><b>'.$MOD_404['TXT_WRONGPAGE'].'</b>:</td><td> '.$res['url'].' <br>
<tr><td><b>&nbsp;&nbsp;&nbsp; ==> </b></td><td> '.$res['redirect'].'<br>
<tr><td><b>'.$MOD_404['TXT_REFERER'].'</b>:</td><td>  '.$res['referer'].'<br>
<tr><td><b>'.$MOD_404['TXT_REMOTEIP'].'</b>:</td><td>  '.$res['ip'].'<br>
<tr><td><b>'.$MOD_404['TXT_REMOTEHOST'].'</b>:</td><td>  '.$res['host'].'<br>
<tr><td><b>'.$MOD_404['TXT_BROWSER'].'</b>:</td><td>  '.$res['browser'].'<br>
<tr><td><b>60 minute repeated</b>:</td><td>  '.$count_errors.'<br>
</table>
</div></div></td>';
			$rval .= '<td style="background:#fff;overflow: hidden; text-overflow: ellipsis; white-space: nowrap" title="'.$title_url.'">'.$url.'</td>';
			$rval .= '</tr>';
		}
	}
	$rval .= '</table>';	
	return $rval;
}

function _404_mailheader() {
	$rval = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <title>404 Page not found</title>
        <style type="text/css">
        body {margin: 0; padding: 0; min-width: 100%!important; font-size:12px; font-family: Verdana, Arial, sans-serif; }
        .content {padding: 0 3%; width: 94%;}  
        </style>
    </head>
    <body>
	<div class="content">
	';
	return $rval;
}
function _404_mailfooter() {
	$rval = '<br><br><div style="text-align:center;color:#ffffff;padding:10px 0px;background:#428BCA">404 module by <a style="color:#ffffff;" href="https://dev4me.com/modules-snippets/opensource/404/">Dev4me</a></div>';
	$rval .= '<br><br></div></body></html>';
	return $rval;
}

function _404_log($url, $page_link = '') {
	global $MOD_404, $database;

	$http 	= isset($_SERVER['HTTPS']) ? "https://":"http://";
	$url 	= $http.$url;
	$detect_url = strpos($url,"?") ? substr($url,0,strpos($url,"?")) : $url;
	$detect_url = _404_escapeString($detect_url);
	$ref 	= _404_escapeString(_404_referer());
	$time 	= time();
	$old 	= time() - (14 * 24 * 60 * 60); // Delete all older than 14 days..
	$last 	= time() - (6 * 60 * 60); // report same link only once per 6 hours
	$ip 	= $_SERVER['REMOTE_ADDR'];
	$iphash = md5($ip);
	$uagent = _404_escapeString(@$_SERVER['HTTP_USER_AGENT']);
	$warning = '0';
	$host = '';
	//cleanup
	$database->query("DELETE FROM ".TABLE_PREFIX."mod_404_errors WHERE `timestamp` < '$old'");
	
	
	$url = _404_escapeString($url);
	$database->query("INSERT INTO ".TABLE_PREFIX."mod_404_errors SET 
		`url`='$url',
		`referer`='$ref',
		`timestamp`='$time',
		`redirect`='$page_link', 
		`ip`='$ip', 
		`iphash`='$iphash', 
		`host`='$host', 
		`browser`='$uagent', 
		`warning`='$warning'
		");
		
		
	_404_blacklist($iphash, $url , 1, 5) ; // 5 times in one hour.. block 404

	$cfg = _404_getcfg();
	if($cfg['storeip'] == '0') {
		$ip = _404_anonymize_ip($ip);
	} else {
		$host 	= gethostbyaddr($ip);
	}
	if($cfg['interval'] == 0) {
		$warning_sent = $database->get_one("SELECT count(`url`) FROM ".TABLE_PREFIX."mod_404_errors WHERE `url` LIKE '{$detect_url}%' AND `timestamp` > '$last' AND `warning`='1'");
		$nosend = $cfg['withref'] && (!$ref || $ref == '-') ? true : false;
		if(!$nosend && !$page_link && !$warning_sent) {
			$warning = '1';
			$email = $cfg['email'];
			$subject = $cfg['subject'];
			if($email) {
				$count = $database->get_one("SELECT count(`url`) FROM ".TABLE_PREFIX."mod_404_errors WHERE `url` LIKE '{$detect_url}%'");
				$counter = $count > '1' ? " - (".$MOD_404['TXT_COUNTER'].": $count)":"";
				
				$html_message = _404_mailheader();
				$html_message .= '<h2>'.$MOD_404['TXT_SUBJECT'].'</h2>';
				$html_message .= '<b>'.$MOD_404['TXT_WEBSITE'].'</b>: '.WEBSITE_TITLE.' ('.WB_URL.')<br>';
				$html_message .= '<b>'.$MOD_404['TXT_TIMESTAMP'].'</b>: '.date(DATE_FORMAT.' '.TIME_FORMAT, time() + DEFAULT_TIMEZONE).'<br><br>';
				$html_message .= '<b>'.$MOD_404['TXT_WRONGPAGE'].'</b>: '.$url.$counter.'<br>';
				$html_message .= '<b>'.$MOD_404['TXT_REFERER'].'</b>: '.$ref.'<br><br>';
				$html_message .= '<b>'.$MOD_404['TXT_REMOTEIP'].'</b>: '.$ip.'<br>';
				if($host) $html_message .= '<b>'.$MOD_404['TXT_REMOTEHOST'].'</b>: '.$host.'<br>';
				$html_message .= '<b>'.$MOD_404['TXT_BROWSER'].'</b>: '.$uagent.'<br>';
				$html_message .= _404_mailfooter();
				
				$plain_message = $MOD_404['TXT_SUBJECT']."\r\n\r\n";
				$plain_message .= $MOD_404['TXT_WEBSITE'].': '.WEBSITE_TITLE.' ('.WB_URL.')'."\r\n";
				$plain_message .= $MOD_404['TXT_TIMESTAMP'].': '.date(DATE_FORMAT.' '.TIME_FORMAT, time() + DEFAULT_TIMEZONE)."\r\n\r\n";
				$plain_message .= $MOD_404['TXT_WRONGPAGE'].': '.$url.$counter."\r\n";
				$plain_message .= $MOD_404['TXT_REFERER'].': '.$ref."\r\n\r\n";
				$plain_message .= $MOD_404['TXT_REMOTEIP'].': '.$ip."\r\n";
				if($host) $plain_message .= $MOD_404['TXT_REMOTEHOST'].': '.$host."\r\n";
				$plain_message .= $MOD_404['TXT_BROWSER'].': '.$uagent."\r\n";
				$plain_message .= "\r\n\r\n** 404 module by https://dev4me.com/ **";

				_404_mail ($email, SERVER_EMAIL, $subject, $html_message, $plain_message );
			}
		} 
	} 
/*
	$url = _404_escapeString($url);
	$database->query("INSERT INTO ".TABLE_PREFIX."mod_404_errors SET 
		`url`='$url',
		`referer`='$ref',
		`timestamp`='$time',
		`redirect`='$page_link', 
		`ip`='$ip', 
		`iphash`='$iphash', 
		`host`='$host', 
		`browser`='$uagent', 
		`warning`='$warning'
		");
*/		
	if($cfg['interval'] > 0) {
		$prev = $time - ($cfg['interval'] * 60 * 60);
		if($cfg['last'] < $prev) {
			if($cfg['last'] == '0') $cfg['last'] = $time - ($cfg['interval'] * 60 * 60); 
			$email = $cfg['email'];
			$subject = $cfg['subject'];
			if($email) {
				require_once 'no-report.php';
				if($result = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404_errors WHERE `timestamp` > '".$cfg['last']."'")) {
					$html_message = _404_mailheader();
					$html_message .= '<h2>'.$MOD_404['TXT_SUBJECT'].'</h2>';
					$html_message .= '<b>'.$MOD_404['TXT_WEBSITE'].'</b>: '.WEBSITE_TITLE.' ('.WB_URL.')';
					$report = false;
					while($row = $result->fetchRow()){
						$skip = false;
						if($cfg['withref']) {
							if(!$row['referer'] || $row['referer'] == '-') $skip = true;
						}
						foreach ( $noUrl as $this_u ) if(stripos($row['url'],$this_u) !== false) $skip = true;
						foreach ( $noBrowser as $this_b ) if(stripos($row['browser'],$this_b) !== false) $skip = true;
						if($row['redirect'] && !$redirected) $skip= true;
						if(!$skip) {
							$report = true;
							$html_message .= '<hr>';
							$html_message .= '<b>'.$MOD_404['TXT_WRONGPAGE'].'</b>: '.str_ireplace(WB_URL,'',$row['url']).'<br>';
							$html_message .= '<b>'.$MOD_404['TXT_REFERER'].'</b>: '.$row['referer'].'<br>';
							$html_message .= '<b>'.$MOD_404['TXT_TIMESTAMP'].'</b>: '.date(DATE_FORMAT.' '.TIME_FORMAT, $row['timestamp'] + DEFAULT_TIMEZONE).'<br>';
							$html_message .= '<b>'.$MOD_404['TXT_REMOTEIP'].'</b>: '.$row['ip'].'<br>';
							if($row['host']) $html_message .= '<b>'.$MOD_404['TXT_REMOTEHOST'].'</b>: '.$row['host'].'<br>';
							$html_message .= '<b>'.$MOD_404['TXT_BROWSER'].'</b>: '.$row['browser'].'<br>';
						}
					}
					$html_message .= _404_mailfooter();
					if($report) _404_mail ($email, SERVER_EMAIL, $subject, $html_message);
				}
			}
			$database->query("UPDATE ".TABLE_PREFIX."mod_404_cfg set `last`='$time'");	
		}
	}
}

function _404_blacklist($iphash, $url , $block_hours = 1, $block_count = 5) {
	global $database;
	$ip = $_SERVER['REMOTE_ADDR'];
	_404_check_blacklist($ip, $url);
	$last 	= time() - ($block_hours * 60 * 60); // get count in 'x' hours
	$count_errors = $database->get_one("SELECT count(`iphash`) FROM ".TABLE_PREFIX."mod_404_errors WHERE `iphash` = '$iphash' AND `timestamp` > '$last'");
	if($count_errors >= $block_count) { // seen as hack attempt
		_404_blacklisthistory_log($ip .' had many ('.$count_errors.') 404 pages ('.$url.')');
		_404_fail('302.3');
	}
}

// Check current IP against a blacklist file. The blacklist has an IP per line. IP can be like 127.0.0.* to block ranges
function _404_check_blacklist($ip, $url) {
	if(!file_exists(__DIR__ . '/blacklist.inc')) { return;	} // No blacklist available
	$blacklist = file(__DIR__ . '/blacklist.inc');
	$ip = (string)$ip;

    if (in_array($ip, $blacklist, true)) {  // the given ip is found directly in the blacklist, reject!
		_404_blacklisthistory_log($ip .' found in blacklist on '.$url);
		_404_fail('302.1');
    }
	
    // go through all blacklisted ips
    foreach ($blacklist as $blacklistIp) {
        $blacklistIp = (string)trim($blacklistIp);
		if(substr($blacklistIp,0,1) == '/') continue;
		if(substr($blacklistIp,0,1) == '#') continue;
        $wildcardPosition = strpos($blacklistIp, "*");  // find the wild card * in blacklisted ip (f.e. find position in "127.0.*" or "127*")
        if ($wildcardPosition === false) { 				// no wild card in blacklisted ip -- continue searching
            continue;
        }
        // cut ip at the position where we got the wildcard on the blacklisted ip and add the wildcard to get the same pattern
        // f.e. we got ip "127.0.0.1" > blacklisted ip "127.0.*" then we compare "127.0.*" with "127.0.*"
		if (substr($ip, 0, $wildcardPosition) . "*" === $blacklistIp) {
			_404_blacklisthistory_log($ip .' found in blacklist ('.$blacklistIp.') on '.$url);
			_404_fail('302.2');
        }
    }
}

function _404_blacklisthistory_log($message) {
    $sLogfile = ini_get ('error_log');
	$sLogfile = dirname($sLogfile).'/blacklist.log.php';
	if(!file_exists($sLogfile)) {
		file_put_contents($sLogfile, "<?php die('illegal file access'); ?>".PHP_EOL);
	}
	$sMsg = date('c').' '.'[BLACKLIST] '.$message.''.PHP_EOL;
    file_put_contents($sLogfile, $sMsg, FILE_APPEND);	
}

function _404_fail($error) {
	http_response_code(intval($error));
	die('<html><head><title>'.$error.' Forbidden</title></head><body><h1>You do not have access to this resource.</h1><p>For additional information, please contact support</p></body></html>');
}

function _404_escapeString($string) {	
	global $database;
	if(!$string) return $string;
	if(is_object($database->DbHandle)) { 
		$rval = $database->escapeString($string);
	} else {
		$rval = mysql_real_escape_string ($string);
	}
	return $rval;
}

function _404_getcfg() {
	global $database;
	$rval = array("id"=>"0", "email"=>"", "subject"=>"", "interval"=>"0", "last"=>"0", "storeip"=>"1", "withref"=>"1", "bakery"=>"0", "oneforall"=>"0");
	if($result = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1")) {
		if($result->numRows()) {
			$rval = $result->fetchRow();
		}
	}
	return $rval;
}
function _404_anonymize_ip($ip) {
  $last_dot = strrpos($ip, '.') + 1;
  return substr($ip, 0, $last_dot). str_repeat('x', strlen($ip) - $last_dot);
}

function _404_short_used() {
	if(file_exists(WB_PATH.'/short.php')) return true;
	if(file_exists(WB_PATH.'/wb.php')) return true;
	return false;
}

function _404_get_one_pages ($page_id, $parent_link = '',$level = 0, $usebakery = 0 , $useofa = -1) {
	global $database;
	$modules = $database->query("SELECT `module` FROM ".TABLE_PREFIX."sections WHERE `page_id`='$page_id'");
	$items = array();
	$ofa = '';
	$level += 1;
	if($modules && $modules->numRows()) {
		while ($module = $modules->fetchRow()) {
			$m = $module['module'];
			if( ($m != 'bakery' && $useofa) || ($m == 'bakery' && $usebakery) ) {
				$res = $database->query("SHOW TABLES LIKE '" . TABLE_PREFIX . "mod_".$m."_items'");
				if($res && $res->numRows()) {
					$ofa = $m;
				}
			}
		}
	}
	if($ofa) {
		$pages = $database->query("SELECT `title`,`link` FROM ".TABLE_PREFIX."mod_".$ofa."_items WHERE `active`='1' AND `page_id`='$page_id'");
		if($pages && $pages->numRows()) {
			while ($page = $pages->fetchRow()) {
				if($ofa == 'bakery') {
					$items[] = $page['link'].SEP3.$page['title'];
				} else {
					$items[] = $parent_link.$page['link'].SEP3.$page['title'];
				}
			}
		}
	}
	return $items;
}


function _404_ofa_used ($ofa = 0) {
	global $database;
	$modules = $database->query("SELECT `module` FROM ".TABLE_PREFIX."sections");
	if($modules && $modules->numRows()) {
		while ($module = $modules->fetchRow()) {
			$m = $module['module'];
			if($m == 'bakery' && !$ofa) return true;
			$res = $database->query("SHOW TABLES LIKE '" . TABLE_PREFIX . "mod_".$m."_items'");
			if($res && $res->numRows()) {
				if($ofa) return true;
			}
		}
	}
	return false;
}

	
?>