<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.6.0
 * @lastmodified    June 17, 2024
 *
 *
 */

// v0.3 changed foldername. Numeric foldernames give unexpected results.
// v0.4 small bugfix in foldernames
// v1.0 added email reports and 30 day history
// v1.1 email reports as digest reports
// v1.2 font change in email report
//      & no-report.php has filters for url and browser/bots
//      & configurable only report with referrer
// v1.3 autodetect oneforall/bakery pages in redirectlist
//		& fix errormessages when not yet configured
//		& fix correct order of rules
// v1.3.1 fix $MESSAGE notice when saving
//      & "<" error in no-report.php
// v1.3.2 fix only use active bakery/oneforall pages
// v1.4 fix for special characters in page titles (thnx dbs)
// v1.4.1 bugfix wrong page-list when sectionpicker is used in the 404 page. (thnx astricia)
// v1.4.2 fixes for MySQL-Strict (Bernd)
// v1.5.0 Max result history 100 items
//		& using WB mailer class to allow smtp for reports
//		& better chek for repeated wrong requests
// v1.6.0 Compairing is done by the longest rules first.
//		& (auto) blacklist functions
//      & security fix
// v1.6.1 Fix upgrade problems WB2.13.

// variables required for Website Baker internal functions (install, uninstall...)
$module_directory 		= 'mod404';
$module_name 			= '404 Page Redirect';
$module_function 		= 'page';
$module_version 		= '1.6.1';
$module_platform 		= '2.10.x';

$module_author 			= 'Ruud Eisinga / Dev4me';
$module_license 		= 'GNU General Public License';
$module_description 	= 'This module redirects 404 pages with a little intelligence';
