<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.6.0
 * @lastmodified    June 17, 2024
 *
 *
 */

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  

$database->query("DROP TABLE IF EXISTS `" .TABLE_PREFIX ."mod_404`");
$mod_create_table = 'CREATE TABLE `' .TABLE_PREFIX .'mod_404` ( '
	. '`404_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,'
	. '`404_wrong` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`404_right` INTEGER UNSIGNED NOT NULL DEFAULT \'0\','
	. '`404_language` VARCHAR(2) NOT NULL DEFAULT \'\','
	. '`404_link` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`404_order` INT(11) NOT NULL DEFAULT \'0\','
	. 'PRIMARY KEY (404_id)'
	. ' )';
$database->query($mod_create_table);

$database->query("DROP TABLE IF EXISTS `" .TABLE_PREFIX ."mod_404_cfg`");
$mod_create_table = 'CREATE TABLE `' .TABLE_PREFIX .'mod_404_cfg` ( '
	. '`id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,'
	. '`email` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`subject` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`interval` INT(5) NOT NULL DEFAULT \'0\','
	. '`last` INT(11) NOT NULL DEFAULT \'0\','
	. '`storeip` INT(1) NOT NULL DEFAULT \'1\','
	. '`withref` INT(1) NOT NULL DEFAULT \'1\','
	. '`bakery` INT(1) NOT NULL DEFAULT \'0\','
	. '`oneforall` INT(1) NOT NULL DEFAULT \'0\','
	. 'PRIMARY KEY (id)'
	. ' )';
$database->query($mod_create_table);

$database->query("DROP TABLE IF EXISTS `" .TABLE_PREFIX ."mod_404_errors`");
$mod_create_table = 'CREATE TABLE `' .TABLE_PREFIX .'mod_404_errors` ( '
	. '`id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,'
	. '`url` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`referer` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`redirect` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`timestamp` INT(11) NOT NULL DEFAULT \'0\','
	. '`ip` VARCHAR(32) NOT NULL DEFAULT \'\','
	. '`host` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`browser` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`warning` INT(1) NOT NULL DEFAULT \'0\','
	. 'PRIMARY KEY (`id`),'
	. 'INDEX `url` (`url`)'
	. ' )';
$database->query($mod_create_table);

?>